#ifdef Hamilton
extern double gsq;       /* sum sqr of Lagr Mult (Hamilton only) */
#endif /*# Hamilton */

#ifdef Lagrange
/*** Lagrange equations of motion ***/
void constraintdynamics(ToIntPtr B, ToIntPtr A, ToIntPtr V);

#ifdef SHAKE
/* Verlet integration + SHAKE; prob is for Maxwell/Andersen thermostat */
void Shake(double eps, double prob);
#endif /*# SHAKE */
#else /*# Lagrange */
/*** Hamilton equations of motion ***/
void constraintdynamics(ToIntPtr B, ToIntPtr A);
#endif /*# Lagrange */

#ifdef POLAR
int selffield(ToIntPtr B,ToIntPtr A,double selfeps);
void mechpolar(ToIntPtr B,ToIntPtr A);
#endif /*# POLAR */

#ifdef SHEAR
void Shear(ToIntPtr B, ToIntPtr A, ToIntPtr VH,double H);
#endif /*# SHEAR */

extern struct constrd_s {
  double dV;    /* for pressure measurements via <dU/dV>, in units of V */
  double Pcorr; /* correction in Pa */
  int mode;     /* see rescalecfg() in norm.c */
  int ncoord;   /* # of coordinates scaled */
  char *PdVname; /* "PdVmol [Pa]" or "PdVatom [Pa]" */
} constrd;

int rescale;     /* what is allowed to rescale (with tau.P, tau.rho, dV):
                    1=x,2=y,4=z,8=CM-based rescaling 
                    initialized to 7 */
   
void measureP(int pass);
