/* ewaldprt.c is include file for ewald.c */

if (charges.sumq!=0 && el.kappa>0) {
  double V=box.L[0]*box.L[1]*box.L[2];
/*.....  double minL=fmin(fmin(L[1],L[0]),L[2]);*/
  double acq=Sqr(el.alpha*box.cutoff);
  double dEr=charges.sumq*sqrt(box.cutoff/2/V)/acq/exp(acq);
  double dfr=2*sqrt(charges.sumq/box.cutoff/V)/exp(acq);
  double eaL=exp(-Sqr(PI/el.alpha*el.kappa));
  double dEk=charges.sumq*el.alpha/(PI*PI*el.kappa*sqrt(V*el.kappa))*eaL;
  double dfk=sqrt(8*charges.sumq/el.kappa/V)*el.alpha/PI*eaL;
  double rat;

  if (el.alpha>=0 && Sqr(charges.sum)/charges.sumq>
#ifdef FLOAT
      2e-9
#else
      2e-18
#endif
    )
#ifdef COOK
      ERROR(("system is charged: SUM q=%g e, sum q^2=%g e\n\
*** (consider option -q-%d)",
             charges.sum/electron,charges.sumq/Sqr(electron),option('q')))
#else
      ERROR(("system is charged: SUM q=%g, sum q^2=%g",
             charges.sum,charges.sumq))
#endif

  prt("\n++++++ Ewald initialized ++++++  alpha = %.6f/A   kappa = %.5f/A",
      el.alpha,el.kappa);

  if ((option('v')&1) && el.alpha>0) { /* <<<<<<<<<<<<<<<<<<<<<<<<<<<< */

    prt(
        "Q->N = #{k,|k|<=K,k=-k} = %i   "
        "Nkk = #{k,|k|<=K,kx>=0,ky>=0,kz>=0} = %i",
        iQ,ikk);
    prt("# of q = %d  SUM(q^2) = %g K*A = %g e^2\n\
SUM(q) = %g  SUM((q/m)^2)=%g",
        Nq,charges.sumq,charges.sumq/Sqr(electron), charges.sum,charges.summq);

    /*** error estimates ***/

    /* standard deviations of expected errors caused by cutoffs */
    prt("\n\
The following estimates are based on the assumption of random distribution of\n\
charges. They work quite well for ionic systems. For dipolar systems without\n\
free charges (e.g., water), the k-space estimates are too pessimistic and\n\
actual errors are roughly 10x smaller; thus, epsk=10*epsr is recommended.");
    /* diagonal (always positive) terms omitted by |k|<K cutoff */
    if (el.diag>=0) 
      prt("* diagonal correction to k-space cutoff error of total energy (%sincluded):\n\
  %g K = %g Eunit",el.diag?"":"not ",
        Ediag,Ediag/Eunit);
    prt("* expected non-diagonal cutoff error of total energy:\n\
  r: %.2e K   = %.2e Eunit     k: %.2e K   = %.2e Eunit",
        dEr,dEr/Eunit,dEk,dEk/Eunit);

    prt("* expected cutoff error of force on maximum charge %g :\n\
  r: %.2e K/A = %.2e Eunit/A   k: %.2e K/A = %.2e Eunit/A",
        charges.max,
        charges.max*dfr,charges.max*dfr/Eunit,
        charges.max*dfk,charges.max*dfk/Eunit);

    rat=charges.max*dfr/el.epsr;
    if (rat>1.03)
      prt("WARNING: estimated r-space error is %.3fx larger than limit epsr=%g K/A",rat,el.epsr);
    rat=charges.max*dfk/el.epsk;
    if (rat>1.03)
      prt("WARNING: estimated k-space error is %.3fx larger than limit epsk=%g K/A",rat,el.epsk);

    /* square roots of sums of squared errors over all charges */
    e=sqrt(charges.sumq);
    prt("* expected standard cutoff error of forces:\n\
  r: %.2e K/A = %.2e Eunit/A   k: %.2e K/A = %.2e Eunit/A",
        e*dfr,e*dfr/Eunit,e*dfk,e*dfk/Eunit);

    e=sqrt(charges.summq);
    prt("* expected standard cutoff error of accelerations:\n\
  r: %.2e A/ps^2                   k: %.2e A/ps^2",
        estimr=e*dfr,estimk=e*dfk);

    } /* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */

  loop (i,0,3)
    if (box.cutoff>box.L[i]*0.50000001)
      prt("WARNING cutoff/box.L[%d] = %.7f > 1/2",i,box.cutoff/box.L[i]); }
