/* NOT FINISHED !!! */
#include "ground.h"
#include "vector.h" /* simglob.h not needed */
#include "sitesite.h"
#ifdef COOK
#  include "units.h"
#  define PROMPT
#else
#  define PROMPT "! "
#endif

/* exp-6 potential, LJ-like combining rules, cf. sim/buck */

void combruleinfo(int comb_rule) /***************************** combruleinfo */
{
  if (comb_rule==1) prt(PROMPT "The Lorentz-Berthelot combing rule:");
  prt(PROMPT "comb_rule&2: atom-atom diameters (sigma) are %s",
      comb_rule&2?"given by the geometric mean":"additive");
  prt(PROMPT "comb_rule&1: atom-atom min. energies (epsilon) are given by the\n\
             %s",  comb_rule&1?"geometric mean":"NOT IMPLEMENTED");
  prt(PROMPT "the stiffness parameters are given by the geometric mean");
}

void initcombrule(siteparm_t *LJ,int comb_rule) /************** initcombrule */
/***
  pre-calculates some constants (like gamma) for the combining rule
  comb_rule&1:
    0 = Kirkwood combining rule (with polarisabilities) for energy terms
    1 = square-root combining rule for energy terms
  comb_rule&6:
    0 = additive (arithmetic mean) diameters
    2 = geometric mean for diameters
  comb_rule for a pair is obtained by `or' operator, i.e. geometric means have
  higher priority
  (if LJ->alpha<=0 then also comb_rule applies for energy terms)
  COOK: includes kcal->K conversion
***/
{
  LJ->combrule=comb_rule | (LJ->alpha<=0);
#ifdef COOK
  LJ->EvdW*=(kcal/Eunit);
#endif
  if (LJ->EvdW>0) {
    WARNING(("EvdW=%g is positive.\n\
*** (EvdW is energy minimum and should not be positive)\n\
*** continuing with EvdW=%g",LJ->EvdW,-LJ->EvdW))
    LJ->EvdW=-LJ->EvdW; }
  LJ->Esqrt=sqrt(-2*LJ->EvdW);

  /* Kirkwood combining rule */
  if (LJ->EvdW!=0) LJ->gamma=Sqr(LJ->alpha)/LJ->EvdW/Pow6(LJ->RvdW)/-256;
  else LJ->gamma=3e37; /* undefined -- solved later */
}

void combrule(pairparm_t *pp,siteparm_t *lj0,siteparm_t *lj1)
/*
  the combining rule
  calculate sigvdW,epsvdW from lj0,lj1
  note that the LJ potential is u(r)=-epsvdW*[(sigvdW/r)^12-2*(sigvdW/r)^6]
  and that epsvdW is negative
  (a general version may have parm[] appended to the list of arguments)
*/
{
  double r,A,B;
  int comb_rule=lj0->comb_rule | lj1->comb_rule;

  if (comb_rule&2) r=Cub(lj0->RvdW*lj1->RvdW*4);
  else r=Pow6(lj0->RvdW + lj1->RvdW);

  if (comb_rule&1)
    B = lj0->Esqrt*lj1->Esqrt*r;
  else
    B = lj0->alpha*lj1->alpha / (lj0->gamma + lj1->gamma);
  A=B*r;

  if (B==0) pp->sig=0; else pp->sig=pow(A/B,1./6);
  if (A==0) pp->eps=0; else pp->eps=B*B/(-2*A);

??

  *A=-eps/(parm[0]-6);
  *B=1/Sqr(sigma);
}

/* calculate auxiliary constants for site-site interactions */
void initssaux(pairaux_t *a,pairparm_t *pp)
{
  a->tau=-(pp->parm[0]/sigvdW);
  a->eu=-6*epsvdW/(pp->parm[0]-6)*exp(pp->parm[0]);
  a->ef=a->eu*(pp->parm[0]/pp->sigvdW);
  a->ru=TURNVDW pp->epsvdW*parm[0]*Pow6(sigvdW)/(pp->parm[0]-6);
  a->rf=TURNVDW 6*a->ru;
}
