/*
  options passed, most of them not needed
*/
extern int optionlist[32];

extern volatile int sig;

/* 
  intialize all species:
    blendfile = name of the blend file (incl. extension)
    LJcutoff = Lennard-Jones cutoff
                (smoothly from about 0.775*LJcutoff to LJcutoff)
*/
void initcook(char *blendfile,double cutoff,double LJcutoff);

/*
  energy of species sp (numbered as in the blend file, starting from 0)
  with coordinates given by r[0]..r[#_OF_SITES-1]
*/
double energy1(int sp,vector *r);

/* as above + pointer to forces returned */
double forces1(int sp,vector *r,vector **pf);

/*
  pair energy of species sp1..sp2 (=sum of all pair interactions)
  does not contain internal terms of sp1 and sp2
*/
double energy2(int sp1,int sp2,vector *r1,vector *r2);

/* as above + pointers to forces returned */
double forces2(int sp1,int sp2,vector *r1,vector *r2,vector **pf1,vector **pf2);

#ifdef SHAKE
extern int shake;
#endif
#ifdef CACHE
extern int by;        /* # of molecules in a subblock */
#endif
#ifdef LINKCELL
extern real over14;  /* factor by which the estimate of change of the max
                     1-2,1-3,1-4 distance is multiplied.
                     Must be >1; the higher, the safer
                     negative: also print distances and speeds
                     1.5 is pessimistic for proteins,
                     but just enough for water */
#endif
#if PARALLEL==1 || PARALLEL==3
extern int measureserial;
#endif
