/* cc -O2 -o cutprt cutprt.c
8/2007: table test changed to at least 64 - or =
moved to util/
*/
#include "../gen/include.h"

void cr(char *l)
/* converts CR [LF] into LF */
{
  char *c=strchr(l,13);
 
  if (c) {
    *c++='\n';
    if (*c=='\n') *c=0; }
}

int main(int narg,char **arg)
{
  int i,j,filter;
  FILE *in,*out;
  char last[256]="?\n",line[256],fn[256],l0[80],l1[80];
  struct ll_s {
    struct ll_s *next;
    char *l; } *head=NULL,*l,**la,*lnext;
  char *tmp="cutprt$.tmp";

  if (narg<2) {
    fprintf(stderr,"Shortens prt-files leaving first header and final statistics. Call by:\n\
   cutprt [-]FILE.prt [[-]FILE.prt ...]\n\
FILE.prt:  rewrites file, old one renamed to FILE.%s, time stamp copied\n\
-FILE.prt: output to stdout"
#ifdef DOS
   ,"prx"
#else
   "\n","prt~"
#endif
      );
    exit(0); }

  loop (i,1,narg) {
    filter=arg[i][0]=='-';
    fprintf(stderr,"opening %s (%s)\n",
	    arg[i]+filter,filter?"to stdout":"backup and replace");

    if (!filter) {
      strcpy(fn,arg[i]+filter);
#ifdef DOS
      fn[strlen(fn)-1]='x';
#else
      strcat(fn,"~");
#endif
      out=fopen(tmp,"wt");
      if (!out) Error("cannot open tmp file"); }
    else
      out=stdout;

    in=fopen(arg[i]+filter,"rt");
    if (!in) Error(arg[i]+filter);

    for (;;) {
      if (!fgets(line,256,in)) Error("main table not found");
      cr(line);
      fputs(line,out);
      if (!memcmp(line,"----------------------------------------------------------------",64))
	break; }

    loop (j,0,2) {
      if (!fgets(line,256,in)) Error("no end of main table");
      cr(line);
      fputs(line,out); }
    alloczero(head,sizeof(*head));
    la=&head; l=head;

    for (;;) {
      int prtit=0;
      char *nl;
      
      memset(l0,0,80);
      memset(l1,0,80);

      if (!fgets(line,256,in)) goto end;
      cr(line);
      if (!memcmp(line,"================================================================",64)) {
	strcpy(last,l->l);
	for (l=head; l; l=lnext) {
	  if (strstr(l->l,"WARNING")) {
	    prtit=4;
	    if (!memcmp(l->l,"*** WARNING in ",15)) prtit++; }
	  if (prtit) {
	    if (prtit==5) {
	      if (*l1) fprintf(out,"...\n%s\n",l1);
	      if (*l0) fprintf(out,"%s\n",l0); }
	    fputs(l->l,out); 
	    if (prtit>2) fputs(l->l,stderr); 
	    prtit--; }
	  if (strlen(l0)>79) Error("internal");
	  strcpy(l1,l0);
	  if (!l->l) Error("internal");
	  memcpy(l0,l->l,79);
	  if (nl=strchr(l0,'\n')) *nl=0;

	  free(l->l); lnext=l->next; free(l); }
	la=&head; }
      alloczero(*la,sizeof(struct ll_s));
      if (!((*la)->l=strdup(line))) Error("no heap");
      l=*la;
      la=&((*la)->next); }

  end:
    fclose(in);
    fputs("...\n",out);
    fputs(last,out);
    for (l=head; l; l=l->next) fputs(l->l,out);

    if (!filter) {
      fclose(out);

      if (!remove(fn)) fprintf(stderr,"%s removed\n",fn);
      fprintf(stderr,"renaming %s to %s\n",arg[i],fn);
      if (rename(arg[i],fn)) Error("could not rename");
      fprintf(stderr,"renaming temporary %s to %s\n",tmp,arg[i]);
      if (rename(tmp,arg[i])) Error("could not rename temporary file\n"); 
      fprintf(stderr,"copying time stamp\n");
      if (system(string("touch -r \"%s\" \"%s\"",fn,arg[i]))) 
        fprintf(stderr,"%s: cannot copy time stamp\n",arg[i]); } }

  return 0;
}
